(*                 E M U L A T E U R   D ' A N S I        
                   ===============================
                           (Juillet 1991)                  

   Cette unit crite en TP (6.0) permet d'afficher du texte  l'cran
   en tenant compte des commandes ANSI. Le texte  afficher doit lui
   tre envoy caractre par caractre. Ce qui lui permet d'tre utilise
   dans un programme de tlcommunication.
   L'unit comporte une seule procdure :  PrintChar_Ans qui demande le
   caractre  afficher comme paramtre d'entre.
   
   L'unit fait appel  une Procdure appele SendStr qui envoie un String
   par le port de communication. SendStr est un nom gnrique que vous devez
   remplacer par le nom d'une de vos procdures qui fait la mme action.
   SendStr est utilise ici pour renvoyer la position courante du curseur
   lorsque le correspondant l'a demande par la commande ANSI "ESC[6N". 
   Certains serveurs font appel  cette commande pour dterminer si le User
   est compatible ANSI (une rponse  leur requte signifie que oui).
   Si cette unit n'est pas employe dans un environnement de communication
   (pour afficher un fichier Ansi par ex.), vous pouvez effacer la partie 
   qui fait appel  SendStr (dans le Case of, option 'N').

   Il est possible d'acclrer l'affichage en crivant directement en mmoire
   vido et en modifiant directement les attributs. Ce n'est pas excessive-
   ment compliqu. Mais je ne l'ai fait ici pour une question de portabilit
   et de simplicit.

   Auteur : Emmanuel GERVY                     
   Pour contact : Rue de l'Ascension 19
                      1460 ITTRE
                       BELGIUM
   ou laissez-moi un message sur RTV-SAT BBS (32-02-4605351).
 
  *************************************************************************)


Unit EmulAnsi;

(*******)
INTERFACE
(*******)

Uses Crt;

Const MaxEr = 20; (* Nbre de caractres maximum  recevoir avant de *)
                  (* considrer la commande comme errone (problme *)
                  (* de transfert).                                 *)

Var Buff      : String[MaxEr+1];  (* Buffer contenant les paramtres ANSI *)
    A_Escape,            (* Vrai si reu le premier caractre ANSI : ESC *)
    A_Escape2 : Boolean; (* Vrai si reu le deuxime caractre ANSI : [ *)
    PosBuff   : Byte;    (* Pointeur du buffer Buff *)
    HV,                  (* Vrai si criture en haute intensit (High Video) *)
    Clig  : Boolean;     (* Vrai si criture en clignotement *)
    SaveX,               (* Contient la position X sauvegarde du curseur *)
    SaveY     : Byte;    (* idem pour Y *)

Procedure PrintChar_Ans (Caract : Char);
(* Affiche Caract  l'cran en tenant compte des commandes ANSI. *)


(************)
IMPLEMENTATION
(************)


Procedure PrintChar_Ans;
Const
  C_Ansi : Set of Char = ['H','F','A','B','C','D','N','J','M','S','U','K'];
      (* Ensemble des commandes ANSI utilises *)


Procedure Ansi;
(* Traite les commandes ANSI *)

Const MaxParam = 20;  (* Nbre maximum de paramtres pour une commande ANSI. *)

Var Tab : Array [1..MaxParam] of Byte;  (* Contient les params de la commande *)
    Coul,         (* Couleur des caracts  afficher *)
    Nbr_Num,      (* Nbre de paramtres ANSI dans la commande *)
    Nbr_Chifr,    (* Nbre de chiffres par paramtre *)
    i, x : Byte;  (* Compteurs *)
    XStr, YStr : String[2];   (* Pour envoyer les coordonnes du curseur. *)

BEGIN
Nbr_Num := 0;
Nbr_Chifr := 1;
x := 1;
Tab[1] := 1;     (* Par dfaut, d'aprs ANSI, les param valent 1, *)
Tab[2] := 1;     (* et on n'utilise jamais plus de 2 paramtres  *)
                 (* la fois dans l'implmentation Pascal.         *)
While (x <> PosBuff) do     (* Tant qu'on a pas scann tout les caract *)
   BEGIN                    (* du buffer on analyse son contenu.       *)
   If Nbr_Num = 0 Then Inc (Nbr_Num);
   If (Buff[x] in ['0'..'9']) And (Nbr_Chifr < 3) Then
      BEGIN
         (* Si le caractre du buffer trait est un chiffre *)
         (* on en fait un nbre avec le chiffre prcdent. Nbre < 100. *)
      If Nbr_Chifr = 1 Then Tab [Nbr_Num] := (Ord (Buff[x]) - 48)
      Else Tab [Nbr_Num] := (Tab [Nbr_Num] * 10) + (Ord (Buff[x]) - 48);
      Inc (Nbr_Chifr);
      END
   Else If Buff[x] = ';' Then  (* Si dlimiteur, on met  jour les pointeurs *)
            BEGIN
                (* Si pas de chiffre avant le ";" on considre ce param
                   comme gal  1. Peut arriver si problme de transfert. *)
            If (Nbr_Chifr = 1) Then Tab [Nbr_Num] := 1;
            Inc (Nbr_Num);
            Nbr_Chifr := 1;
            END;
   Inc (x);
   END;  (* While *)

Case Buff [PosBuff] of     (* Traitement de la commande *)
      'M' : For i := 1 to Nbr_Num do
               Case Tab [i] of
               0  : BEGIN         (* Reset *)
                    TextColor (7);
                    TextBackGround (0);
                    HV := False;
                    Clig := False;
                    END;
               1  : BEGIN         (* Haute intensit *)
                    HV := True;
                    Coul := (TextAttr and 15);          (* Couleur courante ? *)
                    If Coul < 8 Then Coul := Coul + 8; (* Si basse intensit *)
                    TextColor (Coul);                  (* alors met en HV *)
                    END;
               5  : Clig := True; (* Clignotant *)
               7  : BEGIN         (* Inverse vido *)
                    Coul := (TextAttr and 15);      (* couleur car. courante ? *)
                    If Coul > 8 Then Dec (Coul, 8);
                    Coul2 := ((TextAttr Shr 4) and 7); (* idem pour le fond *)
                    TextColor (Coul2);
                    TextBackGround (Coul);
                    END;
               8  : BEGIN         (* Dissimulation *)
                    Coul := ((TextAttr Shr 3) and 7); (* couleur de fond? *)
                    TextColor (Coul);
                    END;
               30..37 : BEGIN     (* couleur de caractre *)
                        Case Tab [i] of
                        30 : Coul := 0;
                        31 : Coul := 4;
                        32 : Coul := 2;
                        33 : Coul := 6;
                        34 : Coul := 1;
                        35 : Coul := 5;
                        36 : Coul := 3;
                        37 : Coul := 7;
                        END;
                        If HV Then Inc (Coul, 8);
                        If Clig Then Inc (Coul, 128);
                        TextColor (Coul);
                        END;
               40 : TextBackGround (0);   (* Couleurs de fond *)
               41 : TextBackGround (4);
               42 : TextBackGround (2);
               43 : TextBackGround (6);
               44 : TextBackGround (1);
               45 : TextBackGround (5);
               46 : TextBackGround (3);
               47 : TextBackGround (7);
               END;
  'H','F' : GotoXy (Tab[2], Tab[1]);
      'A' : GotoXy (WhereX, WhereY - Tab [1]);
      'B' : GotoXy (WhereX, WhereY + Tab [1]);
      'C' : GotoXy (WhereX + Tab [1], WhereY);
      'D' : GotoXy (WhereX - Tab [1], WhereY);
      'N' : BEGIN    (* Envoie par le port de comm les coord. du curseur *)
            Str (WhereX, XStr);     (* SendStr (ou un autre nom) doit tre *)
            Str (WhereY, YStr);     (* une proc qui envoie un string au port. *)
            (* SendStr (#27 + '[' + XStr + ';' + YStr + 'R'); *)
            END;
      'J' : ClrScr;
      'S' : BEGIN                  (* Sauvegarde de la position du curseur *)
            SaveX := WhereX;
            SaveY := WhereY;
            END;
      'U' : GotoXy (SaveX,SaveY);  (* Restitution de la pos du curseur *)
      'K' : ClrEol;                (* Efface la ligne  partir du curseur *)
       END;  (* Case of *)
END;  (* Ansi *)


BEGIN (* de PrintChar_Ans *)
If Ord (Caract) = 27 Then A_Escape := True
Else If (Ord (Caract) = 91) and A_Escape Then A_Escape2 := True
     Else If A_Escape and A_Escape2 Then  (* Les caractres qui suivent *)
              BEGIN                       (* seront ceux de la commande ANSI *)
              Inc (PosBuff);
              Buff [PosBuff] := UpCase (Caract);   (* Caract reu -> buffer *)
              If PosBuff < MaxEr Then
                BEGIN
                If UpCase (Caract) in C_Ansi Then  (* Dernire lettre de la *)
                       BEGIN                       (* commande est reue. *)
                       Ansi;                       (* => trt de la commande. *)
                       A_Escape := False;
                       A_Escape2 := False;
                       PosBuff := 0;
                       END;
                END
              Else BEGIN                (* Si on a reu + de MaxEr caractres *)
                   A_Escape := False;   (* on peut dire qu'il y a eu un       *)
                   A_Escape2 := False;  (* problme de transfert.             *)
                   PosBuff := 0;        (* => rinit du pointeur du buffer.   *)
                   END;
              END
          Else Write (Caract);          (* Affiche le caract qui ne fait pas *)
END;                                    (* partie d'une commande ANSI. *)



BEGIN  (* Unit Princ *)
FillChar (Buff, MaxEr+1, ' ');          (* Init du buffer *)
HV := False;                            (* Inits des variables *)
Clig := False;
A_Escape := False;
A_Escape2 := False;
PosBuff := 0;
SaveX := 1;
SaveY := 1;
END. (* Unit Princ *)
